"""
Meabook controller class
"""

class MeabookController:
    def __init__(self, model, view_class, config):
        self.config = config
        self.model = model
        self.view = view_class(self)
        self.view.start()

    def stop(self):
        """Exit the program."""

        self.config.set_last_active_level(self.view.get_current_level())
        self.model.close()

    def get_items(self, parent=0):
        """Gets from model items with selected level."""

        folders_list = list(self.get_all_folders(parent))
        files_list = [(fields['cn'], internal_name, 'file') for internal_name, \
            fields in self.model.get_files(['cn'], parent).items()]
        return folders_list + files_list

    def get_item(self, _id):
        """Gets person info."""

        return self.model.get_entry_by_id(_id)

    def get_all_folders(self, parent=0):
        """Gets all filials."""

        return [(name, internal_name, 'folder') for name, internal_name in \
            self.model.get_folders(parent)]

    def get_all_subfolders(self):
        """Gets all departments."""

        return [(name, internal_name, 'folder') for name, internal_name in \
            self.model.get_folders()]

    def get_all_files(self):
        """Gets all peoples."""

        # FIXME: read field names from Config
        files_dict = self.model.get_files(['cn'])
        return [(files_dict[internal_name]['cn'], internal_name, 'file') for \
            internal_name in files_dict]

    def get_fields(self):
        """Returns all exists fields from model."""

        return self.model.get_fields()
